/*
 * videoplayer.cpp
 *
 */

#include <iostream>

#include "Timer.h"
#include "FrameRenderer.h"
#include "Slider.h"

int main() {
	std::cout << "Observer - Push" << std::endl;
	// create subject
	Timer clock;
	// create observers and pass them the address of the subject, to let them register themselves
	FrameRenderer display(&clock);
	Slider* progressBar = new Slider(&clock);
	// update subject
	for (int i = 0; i < 10; i++)
		clock.tick();
	// dynamically change the number of observers
	delete progressBar;
	// continue to update the subject
	for (int i = 0; i < 6; i++)
		clock.tick();

}
